"use strict";
var UnoverlayVue = (() => {
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
    get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
  }) : x)(function(x) {
    if (typeof require !== "undefined")
      return require.apply(this, arguments);
    throw new Error('Dynamic require of "' + x + '" is not supported');
  });
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

  // src/index.ts
  var src_exports = {};
  __export(src_exports, {
    OverlayProvider: () => OverlayProvider,
    createOverlay: () => createOverlay,
    default: () => src_default,
    executeOverlay: () => executeOverlay,
    install: () => install,
    useOverlayMeta: () => useOverlayMeta
  });
  var import_vue_demi4 = __require("vue-demi");

  // src/internal/index.ts
  var context = {
    appContext: null
  };
  var OverlayMetaKey = Symbol("__imperative_overlay_key");

  // src/meta.ts
  var import_vue_demi3 = __require("vue-demi");
  var import_core = __require("@vueuse/core");

  // src/transform.ts
  var import_vue_demi2 = __require("vue-demi");

  // src/helper/render.ts
  var import_vue_demi = __require("vue-demi");
  var renderInstance = (component, props, options = {}) => {
    const vanish = () => {
      (0, import_vue_demi.render)(null, container);
    };
    const Provider = (0, import_vue_demi.defineComponent)({
      name: `${component.name}OverlayProvider`,
      setup() {
        var _a;
        (_a = options.provide) == null ? void 0 : _a.call(options, vnode, vanish);
      },
      render() {
        return (0, import_vue_demi.h)(component, props);
      }
    });
    const container = document.createElement("div");
    container.className = "overlay-container";
    const vnode = (0, import_vue_demi.createVNode)(Provider, props);
    vnode.appContext = options.appContext || context.appContext;
    (0, import_vue_demi.render)(vnode, container);
    if (container.firstElementChild) {
      const root = options.root || document.body;
      root.append(container.firstElementChild);
    }
    return { vanish, vnode };
  };

  // src/transform.ts
  function createOverlay(component) {
    const executor = (props, promiser, mountOptions) => {
      const { reject, resolve, promise } = promiser;
      renderInstance(component, props, {
        appContext: mountOptions == null ? void 0 : mountOptions.appContext,
        root: mountOptions == null ? void 0 : mountOptions.root,
        provide: (vnode, _vanish) => {
          const visible = (0, import_vue_demi2.ref)(false);
          function cancel(value) {
            reject == null ? void 0 : reject(value);
            visible.value = false;
          }
          function confirm(value) {
            resolve == null ? void 0 : resolve(value);
            visible.value = false;
          }
          function vanish() {
            _vanish == null ? void 0 : _vanish();
            reject == null ? void 0 : reject();
          }
          promise.confirm = confirm;
          promise.cancel = cancel;
          (0, import_vue_demi2.provide)(OverlayMetaKey, {
            cancel,
            confirm,
            vanish,
            visible,
            vnode
          });
        }
      });
    };
    const caller = (props, options) => {
      const promiser = createPromiser();
      const notAllowedError = function() {
        throw new Error("overlay - Error: It is not allowed to call confirm and cancel externally immediately, please wait for the component to render");
      };
      promiser.promise.confirm = notAllowedError;
      promiser.promise.cancel = notAllowedError;
      executor(props, promiser, options);
      return promiser.promise;
    };
    return caller;
  }
  function createPromiser() {
    let resolve;
    let reject;
    const promise = new Promise((_resolve, _reject) => {
      resolve = _resolve;
      reject = _reject;
    });
    return { promise, reject, resolve };
  }

  // src/utils.ts
  function executeOverlay(component, options) {
    return createOverlay(component)(options == null ? void 0 : options.props, options);
  }
  function delay(milliseconds) {
    return new Promise((resolve) => setTimeout(resolve, milliseconds));
  }
  var noop = () => {
  };

  // src/meta.ts
  function useOverlayMeta(options = {}) {
    const { animation = 0, immediate = true, model = "visible", automatic = true } = options;
    const defaultMeta = getTemplateMeta(model, options);
    const meta = (0, import_vue_demi3.inject)(OverlayMetaKey, defaultMeta) || defaultMeta;
    if (!meta.isTemplate && automatic) {
      (0, import_vue_demi3.watch)(meta.visible, async () => {
        var _a;
        if (meta.visible.value)
          return void 0;
        if (animation > 0)
          await delay(animation);
        (_a = meta.vanish) == null ? void 0 : _a.call(meta);
      });
    }
    if (immediate)
      (0, import_vue_demi3.onMounted)(() => meta.visible.value = true);
    (0, import_vue_demi3.provide)(OverlayMetaKey, null);
    return meta;
  }
  function getTemplateMeta(model, options = {}) {
    const instance = (0, import_vue_demi3.getCurrentInstance)();
    const visible = instance ? (0, import_core.useVModel)(instance.props, model) : (0, import_vue_demi3.ref)(false);
    const cancel = (value) => {
      visible.value = false;
      instance == null ? void 0 : instance.emit(options.cancel || "cancel", value);
    };
    const confirm = (value) => {
      visible.value = false;
      instance == null ? void 0 : instance.emit(options.confirm || "confirm", value);
    };
    return {
      cancel,
      confirm,
      vanish: noop,
      visible,
      isTemplate: true
    };
  }

  // src/index.ts
  var install = (app) => {
    context.appContext = app._context;
  };
  var unoverlay = { install };
  var OverlayProvider = (0, import_vue_demi4.defineComponent)({
    setup(_, { slots }) {
      const { appContext } = (0, import_vue_demi4.getCurrentInstance)();
      context.appContext = appContext;
      return () => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots);
      };
    }
  });
  var src_default = unoverlay;
  return __toCommonJS(src_exports);
})();
//# sourceMappingURL=index.iife.js.map
